#pragma once

#include "scene_node_entity.h"
#include "utils/drop.h"
#include "raylib.h"

typedef struct CameraNode {
    SceneNode *node;
} CameraNode;

void CameraNodeEnterTree(CameraNode *self);
void CameraNodeExitTree(CameraNode *self);
void CameraNodeTick(CameraNode *self, double delta);
Camera3D CameraNodeGetCamera(CameraNode *self);

impl_default_Drop_for(CameraNode);
impl_SceneNodeEntity_for(CameraNode, CameraNodeEnterTree, CameraNodeExitTree, CameraNodeTick);

